# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' A single iteration of the Lorenz 04 model
#'
#' @param XX initial state
#' @param F_Lor F from the Lorenz 04 model
#' @param K_Lor K from the Lorenz 04 model
#' @param dt time step
#' @param M the number of steps that make a time step
#' @param order the order of RK method to use
#' @return dx the increment to reach the new state
#' @export
DeltaLorenz04M2Cpp <- function(X0, F, K, dt, M, newAlgo) {
    .Call('_VEnKF_DeltaLorenz04M2Cpp', PACKAGE = 'VEnKF', X0, F, K, dt, M, newAlgo)
}

#' Simulate from the Lorenz 04 model
#'
#' @param Xinit initial state
#' @param F_Lor F from the Lorenz 04 model
#' @param K_Lor K from the Lorenz 04 model
#' @param dt time step
#' @param M the number of steps that make a time step
#' @param iter number of iterations
#' @param burn how many steps to discard
#' @return Xiter values of all iterations
#' @export
Lorenz04M2SimCpp <- function(Xinit, F_Lor, K_Lor, dt, M, iter, burn, newAlgo) {
    .Call('_VEnKF_Lorenz04M2SimCpp', PACKAGE = 'VEnKF', Xinit, F_Lor, K_Lor, dt, M, iter, burn, newAlgo)
}

#' Gradient for the Lorenz model
#'
#' @param Xinit initial state
#' @param K_Lor K from the Lorenz 04 model
#' @param M the number of steps that make a time step
#' @param dt time step
#' @param F_Lor F from the Lorenz 04 model
#' @export
exactGradient <- function(X, K, M, dt, F) {
    .Call('_VEnKF_exactGradient', PACKAGE = 'VEnKF', X, K, M, dt, F)
}

#' Calculate the exact gradient in the Lorenz model
#'
#' @param X the vector at which to evaluate the gradient
#' @param K parameter from the Lorenz model
#' @return grad the matrix with the gradient
#' @export
exactGrad <- function(X, K) {
    .Call('_VEnKF_exactGrad', PACKAGE = 'VEnKF', X, K)
}

#' right hand side of the Lorenz model in vector form
#'
#' @param X current state
#' @param K parameter from the Lorenz 04 model
#' @param F parameter from the Lorenz 04 model
#' @export
RHS <- function(X, K, F) {
    .Call('_VEnKF_RHS', PACKAGE = 'VEnKF', X, K, F)
}

